function [nodes] = nodes_of_a_complete_binary_tree(n)
%Creates the nodes of a complete binary tree. For the nodes structure, see the documentation of treeplot (doc treeplot).
%
%Arguments:
%   n: number of levels => 2^n-1 nodes.
%
%Output:
%   nodes: row vector.
%----------------------
%Copyright (C) 2012 Zoltan Szabo (szzoli@cs.elte.hu)
%
%This file is part of the OSDL (Online Group-Structured Dictionary Learning) Matlab toolbox.
%
%OSDL is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by
%the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
%
%This software is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
%MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
%
%You should have received a copy of the GNU General Public License along with OSDL. If not, see <http://www.gnu.org/licenses/>.
%---------------------

nodes = [0 kron([1:2^(n-1)-1],[1,1])]; %[0, 1,1, 2,2,3,3, 4,4,5,5,6,6,7,7...]

